<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { DynamicScroller } from 'vue-virtual-scroller';
  import { chunkArray } from '~/helpers';

  const scroller = ref<any>();
  const { width } = useElementSize(document.getElementById('cms-container'));
  const itemSize = ref(400);
  const initializing = ref(true);
  const scrollerTarget = computed(() => scroller.value?.$refs?.scroller);
  const props = withDefaults(
    defineProps<{
      id?: string;
      data: Product[];
      isLoadingMore?: boolean;
    }>(),
    {
      id: undefined,
      isLoadingMore: false,
    },
  );

  const emit = defineEmits(['loadMore']);
  const list = computed(() => chunkArray(props.data, chunkSize.value));

  onMounted(() => {
    useInfiniteScroll(
      scroller.value.$refs.scroller.listenerTarget,
      () => {
        if (props.isLoadingMore || initializing.value) return;
        nextTick(() => {
          emit('loadMore');
        });
      },
      { distance: 10, interval: 1000 },
    );
    initializing.value = false;
  });

  const chunkSize = computed(() => {
    if (width.value >= 1920) {
      return 5;
    } else if (width.value >= 1024) {
      return 4;
    } else if (width.value >= 768) {
      return 3;
    } else {
      return 2;
    }
  });

  defineExpose({ scrollerTarget });
</script>

<template>
  <DynamicScroller :id="id" ref="scroller" :items="list" :min-item-size="itemSize" page-mode>
    <template #default="{ item, index, active }">
      <DynamicScrollerItem :item="item" :active="active" :data-index="index">
        <div
          class="md:(gap-6 py-3) lg:(gap-10 py-5) grid gap-4 px-1 py-2"
          :style="{
            gridTemplateColumns: `repeat(${chunkSize}, minmax(0, 1fr))`,
          }"
        >
          <template v-for="(product, ind) in item.data" :key="product.id">
            <slot v-bind="{ product, index: index * chunkSize + ind }" />
          </template>
        </div>
      </DynamicScrollerItem>
    </template>
  </DynamicScroller>

  <!-- show empty state -->
  <div v-if="!isLoadingMore && !data.length" class="flex items-center justify-center py-10">
    <h2 class="font-semibold">{{ $t('product.messages.noProductsFound') }}</h2>
  </div>

  <!-- show loading state -->
  <div
    v-if="isLoadingMore"
    class="md:(gap-6 py-3) lg:(gap-10 py-5) grid gap-4 px-1 py-2"
    :style="{
      gridTemplateColumns: `repeat(${chunkSize}, minmax(0, 1fr))`,
    }"
  >
    <SwProductCard v-for="size in chunkSize" :key="size" class="flex-1" :loading="true" />
  </div>
</template>
